/*
 * CommonUtils.c
 *
 *  Created on: 03/11/2013
 *      Author: Tomàs Clar
 */

#include "LPC17xx.h"
#include "CommonUtils.h"
#include "print.h"


#include <string.h>
#include <stdio.h>

unsigned long ulPINState;

void activeDelay(uint32_t ms)
{
	int i;
	// 7140 iterations = 1 ms
	for (i=0; i<(((uint32_t)7140) * ms); i++)
	{

	}
}
void activeDelay_us(uint32_t us)
{
	int i;
	// 7 iterations = 1 us
	for (i=0; i<(((uint32_t)7) * us); i++)
	{

	}
}
/*****************************************************************************
** Function name:		prova_strtok
**
** Descriptions:		Enumerates the parts of a chain which is separated by special characters
**
**
** parameters:			character chain
**
** Returned value:		None
**
*****************************************************************************/

void prova_strtok(char * cadena)
{
	char * pch;
	uint8_t i=0;
	printText(portCP, "--->Parsing\r\n");
	char  buffpch[30];
	pch = strtok(cadena, "#");
	while (pch != NULL)
		{
			i++;
			sprintf(buffpch, "%s[%u]\r\n",pch,i);
			printText(portCP, buffpch);
			pch = strtok(NULL, "#");
		}
	}

/*****************************************************************************
** Function name:		pin_init
**
** Descriptions:		The P0.(16-31) functionality and direction are configured by masks
**
**
** parameters:			port mask, direction mask
**
** Returned value:		None
**
*****************************************************************************/
void pin_init(uint32_t function_mask, uint32_t direction_mask)
{
	//The port/s functionality is configured by function mask.

		LPC_PINCON->PINSEL1	&= ( ~(function_mask) );
	//Fast GPIO Direction PORTx control bits.
	//Bit 0 in FIOxDIR controls pin Px.0, bit 31 in FIOxDIR controls pin Px.31.
		LPC_GPIO0->FIODIR |= (direction_mask);
	}
/*****************************************************************************
** Function name:		pin_off
**
** Descriptions:		The P0.(0-31) turn off pin indicated by mask
**
**
** parameters:			pin_mask
**
** Returned value:		None
**
*****************************************************************************/
void pin_off(uint32_t pin_mask)
{
	ulPINState = LPC_GPIO0->FIOPIN;
	// Si el piu està activat el desactiva. Si esta desactivat no fa res
	LPC_GPIO0->FIOCLR = ulPINState & ( pin_mask );

	}
/*****************************************************************************
** Function name:		pin_on
**
** Descriptions:		The P0.(0-31) turn on pin indicated by mask
**
**
** parameters:			pin_mask
**
** Returned value:		None
**
*****************************************************************************/
void pin_on(uint32_t pin_mask)
{
	ulPINState = LPC_GPIO0->FIOPIN;
	//Si el piu està activat no fa res. Si està desactivat l'activa
	LPC_GPIO0->FIOSET = ( ( ~ulPINState ) & ( pin_mask ) );

	}
