
#include "LPC17xx.h"
#include "led.h"
#include "wifly.h"

/* The bit of port 0 that the LPCXpresso LPC13xx LED is connected. */
#define mainLED_BIT 						( 22 )
unsigned long ulLEDState;

void led_toggle()
{
	//L'alternància s'aconsegueix cridant les funcions led_off() i led_on()
	unsigned long ulLEDStateinit = 0;
	//Aquesta màscara ens servirà per decidir si el led s'ha d'activar o desactivar

	ulLEDStateinit = (1 << mainLED_BIT);

	ulLEDState = LPC_GPIO0->FIOPIN;

	if ((ulLEDStateinit & ulLEDState) == (ulLEDStateinit))
	{
		//El led està activat. Desactiva el led
		led_off();
		}
	else
	{
		//El led està desactivat. Activa el led
		led_on();
		}

	}
/*****************************************************************************
** Function name:		led_init
**
** Descriptions:		The port/s functionality and direction are configured by masks
**
**
** parameters:			port mask
**
** Returned value:		None
**
*****************************************************************************/
void led_init(uint32_t function_mask, uint32_t direction_mask)
{
	//The port/s functionality is configured by function mask.

		LPC_PINCON->PINSEL1	&= ( ~(function_mask) );
	//Fast GPIO Direction PORTx control bits.
	//Bit 0 in FIOxDIR controls pin Px.0, bit 31 in FIOxDIR controls pin Px.31.
		LPC_GPIO0->FIODIR |= (direction_mask);
	}

void led_off()
{
	ulLEDState = LPC_GPIO0->FIOPIN;
	// Si el led està activat el desactiva. Si esta desactivat no fa res
	LPC_GPIO0->FIOCLR = ulLEDState & ( 1 << mainLED_BIT );

	}

void led_on()
{
	ulLEDState = LPC_GPIO0->FIOPIN;
	//Si el led està activat no fa res. Si està desactivat l'activa
	LPC_GPIO0->FIOSET = ( ( ~ulLEDState ) & ( 1 << mainLED_BIT ) );

	}

